﻿--------------------------------------------------------
--				Mage Fever Pet Freeze
--				Kritologist - Malorne

--Widget Event Handlers
local function PetFreezeOnUpdate(self, elapsed)
		if not MageFever3_Options.Showing then
			--MF.PFupdatetime = MF.PFupdatetime + elapsed
			--self.back:SetMinMaxValues(MF.PFcasttime, MF.PFcasttime + 30)
			--self.back:SetValue((MF.MIcasttime + 30) - MF.MIupdatetime)
			--self.SparkFrame.Spark:SetPoint("TOPLEFT", (self.back:GetValue() / (MF.MIcasttime + 30)) * self.back:GetWidth(), self:GetHeight() / 2) 
			--self.back.TimerText:SetText(format("%.1f",(MF.MIcasttime + 30)-(MF.MIcasttime + MF.MIupdatetime)))
		end
end
local function PetFreezeMouseDown(self, button)
		if (not (MageFever3_Options.Lock) ) then
			self:StartMoving();
			self.isMoving = true;
		end
end
local function PetFreezeMouseUp(self, button)
	if ( self.isMoving ) then
			self:StopMovingOrSizing();
			self.isMoving = false;
			MageFeverPetFreeze_Options["X"] = self:GetLeft()
			MageFeverPetFreeze_Options["Y"] =  -self:GetTop()
		end
end
local function PetFreezeOnHide(self)
		if ( self.isMoving ) then
			self:StopMovingOrSizing();
			self.isMoving = false;
		end
end

local function PetFreezeOnEvent(self,event,...)
	local arg1,arg2,arg3,_,_,_,_,_,_,arg10= ...;
	
	if (event == "COMBAT_LOG_EVENT") then	

	end
end

--Widget Creation
function MageFever_CreatePetFreezeFrame()
	local backdrop = {bgFile = "Interface\\Glues\\LoadingBar\\Loading-BarBackground",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 0,
	}
	MF.PetFreeze_Frame = CreateFrame("Frame", "MF.PetFreeze_Frame",  UIParent)
	MF.PetFreeze_Frame:SetPoint("TOPLEFT", MageFeverPetFreeze_Options["X"], MageFeverPetFreeze_Options["Y"])
	MF.PetFreeze_Frame:SetMovable(true)
	MF.PetFreeze_Frame:RegisterForDrag("RightButton")
	MF.PetFreeze_Frame:EnableMouse(true)
	MF.PetFreeze_Frame:SetClampedToScreen(true)
	MF.PetFreeze_Frame:SetFrameStrata("HIGH")	
	MF.PetFreeze_Frame:SetWidth(MageFeverPetFreeze_Options["Width"])
	MF.PetFreeze_Frame:SetHeight(MageFeverPetFreeze_Options["Height"])
	MF.PetFreeze_Frame:SetScale(MageFeverPetFreeze_Options["Scale"])
	MF.PetFreeze_Frame:SetBackdrop(backdrop)
	MF.PetFreeze_Frame:SetBackdropColor(MageFeverPetFreeze_Options["R"],MageFeverPetFreeze_Options["G"],MageFeverPetFreeze_Options["B"],MageFeverPetFreeze_Options["A"])
	MF.PetFreeze_Frame:SetBackdropBorderColor(0,0,0, 0)
		
	MF.PetFreeze_Frame.BarWidth = MageFeverPetFreeze_Options["Width"]
	MF.PetFreeze_Frame.SparkPosition = 0
		
	--MF.PetFreeze_Frame.IconFrame = CreateFrame("Frame", "MIIcon", MF.PetFreeze_Frame)
	--MF.PetFreeze_Frame.IconFrame :SetHeight(MageFeverPetFreeze_Options["Height"])
	--MF.PetFreeze_Frame.IconFrame :SetWidth(MageFeverPetFreeze_Options["Height"])
	--MF.PetFreeze_Frame.IconFrame :SetPoint("TOPLEFT", -MageFeverPetFreeze_Options["Height"],0)
	--MF.PetFreeze_Frame.IconFrame.Icon = MF.PetFreeze_Frame.IconFrame:CreateTexture()
	--MF.PetFreeze_Frame.IconFrame.Icon:SetAllPoints(MF.PetFreeze_Frame.IconFrame)
	
	--local _,_,icon = GetSpellInfo(55342)
	--MF.PetFreeze_Frame.IconFrame.Icon:SetTexture(icon)
		
	MF.PetFreeze_Frame.back = CreateFrame("StatusBar", "PFStatus", MF.PetFreeze_Frame)
	MF.PetFreeze_Frame.back:SetPoint("CENTER")
	MF.PetFreeze_Frame.back:SetWidth(MageFeverPetFreeze_Options["Width"])
	MF.PetFreeze_Frame.back:SetHeight(MageFeverPetFreeze_Options["Height"]) 
	MF.PetFreeze_Frame.back:SetStatusBarTexture("Interface\\PaperDollInfoFrame\\UI-Character-Skills-Bar")
	MF.PetFreeze_Frame.back:SetStatusBarColor(MageFeverPetFreeze_Options["R"],MageFeverPetFreeze_Options["G"],MageFeverPetFreeze_Options["B"],MageFeverPetFreeze_Options["A"])
	MF.PetFreeze_Frame.back:SetMinMaxValues(0, 120)
	MF.PetFreeze_Frame.back:SetValue(120)
		
	MF.PetFreeze_Frame.SparkFrame = CreateFrame("Frame", "PFSpark", MF.PetFreeze_Frame)
	MF.PetFreeze_Frame.SparkFrame:SetAllPoints(MF.PetFreeze_Frame)
	MF.PetFreeze_Frame.SparkFrame.Spark = MF.PetFreeze_Frame.SparkFrame:CreateTexture("MISparkTexture", "ARTWORK")
	MF.PetFreeze_Frame.SparkFrame.Spark:SetPoint("TOPLEFT", 0, 0)
	MF.PetFreeze_Frame.SparkFrame.Spark:SetAlpha(.5)
	MF.PetFreeze_Frame.SparkFrame.Spark:SetHeight(MF.PetFreeze_Frame:GetHeight() * 2) 

				
	MF.PetFreeze_Frame.back.DisplayText = MF.PetFreeze_Frame.back:CreateFontString("PFProcText", "OVERLAY", MF.PetFreeze_Frame.back)
	MF.PetFreeze_Frame.back.DisplayText:SetFont("Fonts\\FRIZQT__.TTF", 10)
	MF.PetFreeze_Frame.back.DisplayText:SetPoint("LEFT", 10, 0)
	MF.PetFreeze_Frame.back.DisplayText:SetText("Freeze")
		
	MF.PetFreeze_Frame:Hide()
	
	MF.PetFreeze_Frame.back.TimerText = MF.PetFreeze_Frame.back:CreateFontString("PFProcTimer", "OVERLAY", MF.PetFreeze_Frame.back)
	MF.PetFreeze_Frame.back.TimerText:SetFont("Fonts\\FRIZQT__.TTF", 10)
	MF.PetFreeze_Frame.back.TimerText:SetPoint("RIGHT", -5, 0)
	MF.PetFreeze_Frame.back.TimerText:SetText("0")
	
	MF.PetFreeze_Frame:RegisterEvent("COMBAT_LOG_EVENT")
	MF.PetFreeze_Frame:SetScript("OnEvent", PetFreezeOnEvent)
	MF.PetFreeze_Frame:SetScript("OnUpdate", PetFreezeOnUpdate)	
	MF.PetFreeze_Frame:SetScript("OnMouseDown", PetFreezeMouseDown)
	MF.PetFreeze_Frame:SetScript("OnMouseUp", PetFreezeMouseUp)	
	MF.PetFreeze_Frame:SetScript("OnHide", PetFreezeOnHide)
end
function MageFever_ToggleMI(self)
	 MageFeverPetFreeze_Options["Show"] = self:GetChecked()
end
function MageFeverPetFreezeWidth(self)
	if MF.MageFeverLoaded then
		MF.PetFreeze_Frame:SetWidth(self:GetValue())
		MageFeverPetFreeze_Options["Width"] = self:GetValue()
		MF.PetFreeze_Frame.back:SetWidth(self:GetValue())
		MF.PetFreeze_Frame.SparkFrame.Spark:SetPoint("TOPLEFT", self:GetValue() - 16, MF.PetFreeze_Frame:GetHeight() / 2 )
	end
end
function MageFeverPetFreezeHeight(self)
	if MF.MageFeverLoaded then
	
		MF.PetFreeze_Frame:SetHeight(self:GetValue())
		MageFeverPetFreeze_Options["Height"] = self:GetValue()
		MF.PetFreeze_Frame.IconFrame:SetHeight(self:GetValue())
		MF.PetFreeze_Frame.IconFrame:SetWidth(self:GetValue())
		MF.PetFreeze_Frame.back:SetHeight(self:GetValue()) -- *.49 for frame with background border
		MF.PetFreeze_Frame.SparkFrame.Spark:SetHeight(self:GetValue()* 2)
		MF.PetFreeze_Frame.SparkFrame.Spark:SetPoint("TOPLEFT", MF.PetFreeze_Frame:GetWidth() - 16 , self:GetValue() / 2 )
	end
end
function MageFeverPetFreezeScale(self)
		if MF.MageFeverLoaded then
			MageFeverPetFreeze_Options["Scale"] = self:GetValue()
			MF.PetFreeze_Frame:SetScale(self:GetValue())
		end
end